// MainFunctions.cpp

#include "stdafx.h"
//#include "mainfunctions.h"
#include "apl_api.h"
//#include "ReportDict.h"
//#include "CommonQuery.h"
#include "SetDocIdDlg.h"

extern HINSTANCE _hDllInstance;

bool GetPrdId(CaplAPI *api, CaplInstance *inst, CString &buf, CWnd *wnd);
bool GetPrdName(CaplAPI *api, CaplInstance *inst, CString &buf, CWnd *wnd);

bool GetDocId(CaplAPI *api, CaplInstance *inst, CString &buf, CWnd *wnd);

/*  :


   bCheckEnableButton == true -   . 
	   true,    ,  false -   


  attr - ,   

  inst -     ,  0 -  .

  buf -                .

  wnd -  ,    

  

  :           
    ItemAttrBuild

*/

__declspec(dllexport) bool ItemAttrBuild(bool bCheckEnableButton, CaplAPI *api, CaplAttr *attr, CaplInstance *inst, CString &buf, CWnd *wnd)
{
	
	if(api==0) return false;
	if(attr==0) return false;


	//*************************************************************
	// 
	//*************************************************************



	
	//  
	if(attr==api->m_prd_mgr.a_prd_id)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		//AfxMessageBox("prd id");
		//buf="prd id";
		//return true;

		return GetPrdId(api,inst,buf,wnd);

		
	}


	//  
	if(attr==api->m_prd_mgr.a_prd_name)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		//AfxMessageBox("prd name");
		//buf="prd name";
		//return true;

		return GetPrdName(api,inst,buf,wnd);
		
	}

	//  
	if(attr==api->m_prd_mgr.a_prd_code)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		AfxMessageBox("prd code");
		buf="prd code";
		return true;
		
	}

	//*************************************************************
	//  
	//*************************************************************

	
	//  
	if(attr==api->m_prd_mgr.a_pdf_id)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		AfxMessageBox("pdf id");
		buf="pdf id";
		return true;
		
	}
	

	//  
	if(attr==api->m_prd_mgr.a_pdf_code)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		AfxMessageBox("pdf code");
		buf="pdf code";
		return true;
		
	}


	// 1 
	/*if(attr==api->m_prd_mgr.a_pdf_code1)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		AfxMessageBox("pdf code1");
		buf="pdf code1";
		return true;
		
	}


	// 2 
	if(attr==api->m_prd_mgr.a_pdf_code2)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		AfxMessageBox("pdf code2");
		buf="pdf code2";
		return true;
		
	}*/


	//*************************************************************
	// 
	//*************************************************************


	//  
	if(attr==api->m_doc_mgr.a_doc_id)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		//AfxMessageBox("doc id");
		//buf="doc id";
		//return true;
		return GetDocId(api,inst,buf,wnd);
		
	}


	//  
	if(attr==api->m_doc_mgr.a_doc_name)
	{
		if(bCheckEnableButton) return true;

		if(inst!=0)
		{
			if(inst->GetAccessmode()>=aplRO)
			{
				AfxMessageBox(" !");
				return false;
			}
		}

		AfxMessageBox("doc name");
		buf="doc name";
		return true;
		
	}


	if(bCheckEnableButton) return false;

	return false;
}

//*******************************************************************************************
//*******************************************************************************************
//*******************************************************************************************

//    

bool GetPrdId(CaplAPI *api, CaplInstance *inst, CString &buf, CWnd *wnd)
{
	if(api==0) return false;


	CString person_name;
	api->m_appr_mgr.GetPersonName(api->m_appr_mgr.GetCurrentPerson(),person_name,true);

	buf="TMP ";
	buf+=person_name;
	buf+=" ";

	
	COleDateTime odt=COleDateTime::GetCurrentTime();
	buf+=odt.Format("%d.%m.%Y  %H:%M:%S");


	/*if(wnd!=0)
	{
		CWnd *edit_name=wnd->GetDlgItem(1001);

		if(edit_name!=0)
		{
			edit_name->SetWindowText(buf);
			((CEdit*)edit_name)->SetReadOnly(TRUE);
		}

	}*/

	
	return true;

}

//*******************************************************************************************
//*******************************************************************************************
//*******************************************************************************************

//    


bool GetPrdName(CaplAPI *api, CaplInstance *inst, CString &buf, CWnd *wnd)
{
	if(api==0) return false;


	CaplInstance *spr_names=api->m_classifier_mgr.GetClassifierSystemById("PRDNAMES",true);
	if(spr_names==0)
	{
		AfxMessageBox("   'PRDNAMES'  ");
		return false;
	}

	CaplInstance *level=0;
	
	api->m_classifier_mgr.SelectItem(&level,spr_names,APL_SELECT_CLASSIFIER_LEVEL);
	if(level==0) return false;

	api->m_data.GetAttr(level,api->m_classifier_mgr.a_apl_classifier_level_name,buf);
	
	return true;

}



//*******************************************************************************************
//*******************************************************************************************
//*******************************************************************************************

//    


bool GetDocId(CaplAPI *api, CaplInstance *inst, CString &buf, CWnd *wnd)
{
	if(api==0) return false;


	HINSTANCE hOldInstance= AfxGetResourceHandle();
	AfxSetResourceHandle(_hDllInstance);

	CSetDocIdDlg dlg;
	dlg.m_id=buf;
	dlg.m_api=api;
	dlg.m_inst=inst;

	int res=dlg.DoModal();
	AfxSetResourceHandle(hOldInstance);

	if(res!=IDOK) return false;

	buf=dlg.m_id;

	/*if(wnd!=0)
	{
		CWnd *edit_name=wnd->GetDlgItem(2001);

		if(edit_name!=0)
		{
			edit_name->SetWindowText(buf);
			((CEdit*)edit_name)->SetReadOnly(TRUE);
		}

	}*/
	
	return true;

}
